'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (filename, rules) {
  var dirname = _path2.default.dirname(filename);
  filename = _path2.default.basename(filename);

  for (var glob in rules) {
    if ((0, _minimatch2.default)(filename, glob)) {
      if (Array.isArray(rules[glob])) {
        var search = rules[glob][0];
        var replacement = rules[glob][1];

        (0, _assert2.default)(typeof replacement === 'string', 'The second params of ' + glob + ' should be string');

        var regex = (0, _toRegExp2.default)(search);
        if (regex) {
          return _path2.default.join(dirname, filename.replace(regex, replacement));
        }

        return _path2.default.join(dirname, filename.split(search).join(replacement));
      }

      return _path2.default.join(dirname, rules[glob]);
    }
  }

  return _path2.default.join(dirname, filename);
};

var _minimatch = require('minimatch');

var _minimatch2 = _interopRequireDefault(_minimatch);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _toRegExp = require('./toRegExp');

var _toRegExp2 = _interopRequireDefault(_toRegExp);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = exports['default'];